require_relative 'command.rb'
require 'twig'
require 'rugged'
require 'highline/import'
require 'aws-sdk-core'

class Prima
  attr_reader :twig, :rugged

  def initialize
    @twig = Twig.new(:read_options => true, :max_days_old => 30)
    @rugged = Rugged::Repository.new('.')
    create_clients
  end

  def create_clients
    Aws.config.update({
      region: 'eu-west-1'
    })
  end

  # proxy di tutti i metodi a rugged
  def method_missing(method)
    @rugged.send method
  end
end
